#pragma once
#include <windows.h>

class WiiRemoteConvert
{
public:
	WiiRemoteConvert(void);
	~WiiRemoteConvert(void);

	struct Point3
	{
		int X;
		int Y;
		int Z;
	};

	struct Point3F
	{
		double X;
		double Y;
		double Z;
	};

	//--WiiRemote-------
	struct WiiButtonState
	{
		bool A;
		bool B;
		bool Minus;
		bool Home;
		bool Plus;
		bool One;
		bool Two;
		bool Up;
		bool Down;
		bool Left;
		bool Right;
	};

	struct WiiRemoteAccelState
	{
		Point3 RawValues;
		Point3F Values;
	};	

	struct WiiRemoteAccelCalibration
	{
		int X0;
		int Y0;
		int Z0;
		int XG;
		int YG;
		int ZG;
	};

	struct WiiRemoteState
	{
		WiiButtonState ButtonState;
		WiiRemoteAccelState AccelState;
		WiiRemoteAccelCalibration AccelCalibrationInfo;
	};

	WiiRemoteState mWiiRemoteState;
	//--WiiRemote񂱂܂-------

	void SetWiiRemoteCalibration(BYTE* buff);
	void ParseButtons(BYTE* buff);
	void ParseAccel(BYTE *buff);
};
