#include "WiiClassicControllerConvert.h"

WiiClassicControllerConvert::WiiClassicControllerConvert(void)
{
}

WiiClassicControllerConvert::~WiiClassicControllerConvert(void)
{
}

void WiiClassicControllerConvert::SetWiiRemoteCalibration(BYTE *buff)
{
	mWiiRemoteState.AccelCalibrationInfo.X0 = buff[6];
	mWiiRemoteState.AccelCalibrationInfo.Y0 = buff[7];
	mWiiRemoteState.AccelCalibrationInfo.Z0 = buff[8];
	mWiiRemoteState.AccelCalibrationInfo.XG = buff[10];
	mWiiRemoteState.AccelCalibrationInfo.YG = buff[11];
	mWiiRemoteState.AccelCalibrationInfo.ZG = buff[12];
}

void WiiClassicControllerConvert::SetWiiClassicControllerCalibration(BYTE *buff)
{
	mWiiClasicControllerState.CalibrationInfo.LeftStick.X0 = 31;
	mWiiClasicControllerState.CalibrationInfo.LeftStick.XMax = 63;
	mWiiClasicControllerState.CalibrationInfo.LeftStick.XMin = 0;
	mWiiClasicControllerState.CalibrationInfo.LeftStick.Y0 = 31;
	mWiiClasicControllerState.CalibrationInfo.LeftStick.YMax = 63;
	mWiiClasicControllerState.CalibrationInfo.LeftStick.YMin = 0;

	mWiiClasicControllerState.CalibrationInfo.RightStick.X0 = 16;
	mWiiClasicControllerState.CalibrationInfo.RightStick.XMax = 31;
	mWiiClasicControllerState.CalibrationInfo.RightStick.XMin = 0;
	mWiiClasicControllerState.CalibrationInfo.RightStick.Y0 = 16;
	mWiiClasicControllerState.CalibrationInfo.RightStick.YMax = 31;
	mWiiClasicControllerState.CalibrationInfo.RightStick.YMin = 0;

	mWiiClasicControllerState.CalibrationInfo.LeftTrigger.Max = 31;
	mWiiClasicControllerState.CalibrationInfo.LeftTrigger.Min = 0;
	
	mWiiClasicControllerState.CalibrationInfo.RightTrigger.Max = 31;
	mWiiClasicControllerState.CalibrationInfo.RightTrigger.Min = 0;
}

void WiiClassicControllerConvert::ParseButtons(BYTE *buff)
{
	mWiiRemoteState.ButtonState.A		= (buff[2] & 0x08) != 0;
	mWiiRemoteState.ButtonState.B		= (buff[2] & 0x04) != 0;
	mWiiRemoteState.ButtonState.Minus	= (buff[2] & 0x10) != 0;
	mWiiRemoteState.ButtonState.Home	= (buff[2] & 0x80) != 0;
	mWiiRemoteState.ButtonState.Plus	= (buff[1] & 0x10) != 0;
	mWiiRemoteState.ButtonState.One	    = (buff[2] & 0x02) != 0;
	mWiiRemoteState.ButtonState.Two   	= (buff[2] & 0x01) != 0;
	mWiiRemoteState.ButtonState.Up	    = (buff[1] & 0x08) != 0;
	mWiiRemoteState.ButtonState.Down	= (buff[1] & 0x04) != 0;
	mWiiRemoteState.ButtonState.Left	= (buff[1] & 0x01) != 0;
	mWiiRemoteState.ButtonState.Right	= (buff[1] & 0x02) != 0;

	mWiiClasicControllerState.ButtonState.A		= (buff[11] & 0x10) == 0;
	mWiiClasicControllerState.ButtonState.B		= (buff[11] & 0x40) == 0;
	mWiiClasicControllerState.ButtonState.X		= (buff[11] & 0x08) == 0;
	mWiiClasicControllerState.ButtonState.Y		= (buff[11] & 0x20) == 0;
	mWiiClasicControllerState.ButtonState.Minus	= (buff[10] & 0x10) == 0;
	mWiiClasicControllerState.ButtonState.Home	= (buff[10] & 0x08) == 0;
	mWiiClasicControllerState.ButtonState.Plus	= (buff[10] & 0x04) == 0;
	mWiiClasicControllerState.ButtonState.Up	= (buff[11] & 0x01) == 0;
	mWiiClasicControllerState.ButtonState.Down	= (buff[10] & 0x40) == 0;
	mWiiClasicControllerState.ButtonState.Left	= (buff[11] & 0x02) == 0;
	mWiiClasicControllerState.ButtonState.Right	= (buff[10] & 0x80) == 0;
	mWiiClasicControllerState.ButtonState.L		= (buff[10] & 0x20) == 0;
	mWiiClasicControllerState.ButtonState.R		= (buff[10] & 0x02) == 0;
	mWiiClasicControllerState.ButtonState.ZL	= (buff[11] & 0x80) == 0;
	mWiiClasicControllerState.ButtonState.ZR	= (buff[11] & 0x04) == 0;
}

void WiiClassicControllerConvert::ParseAccel(BYTE *buff)
{
	mWiiRemoteState.AccelState.RawValues.X = buff[3];
	mWiiRemoteState.AccelState.RawValues.Y = buff[4];
	mWiiRemoteState.AccelState.RawValues.Z = buff[5];

	// Ƃ肠Cf[^ĂD{͕␳Ƃ
	mWiiRemoteState.AccelState.Values.X = buff[3];
	mWiiRemoteState.AccelState.Values.Y = buff[4];
	mWiiRemoteState.AccelState.Values.Z = buff[5];
}

void WiiClassicControllerConvert::ParseAnalog(BYTE *buff)
{
	mWiiClasicControllerState.AnalogState.Left.StickX = (buff[6] & 0x3f);
	mWiiClasicControllerState.AnalogState.Left.StickY = (buff[7] & 0x3f);
	mWiiClasicControllerState.AnalogState.Left.Trigger = (((buff[8] & 0x60)) >> 2 | buff[9] >> 5);
	
	mWiiClasicControllerState.AnalogState.Right.StickX = ((buff[8] >> 7) | ((buff[7] & 0xc0) >> 5) | ((buff[6] & 0xc0) >> 3));
	mWiiClasicControllerState.AnalogState.Right.StickY = (buff[8] & 0x1f);
	mWiiClasicControllerState.AnalogState.Right.Trigger = (buff[9] & 0x1f);
}