#include "WiiNunchakuConvert.h"

WiiNunchakuConvert::WiiNunchakuConvert(void)
{
}

WiiNunchakuConvert::~WiiNunchakuConvert(void)
{
}

void WiiNunchakuConvert::SetWiiExtensionCalibration(BYTE *buff)
{
	NunchukState.CalibrationInfo.AccelCalibration.X0 = buff[6];
	NunchukState.CalibrationInfo.AccelCalibration.Y0 = buff[7];
	NunchukState.CalibrationInfo.AccelCalibration.Z0 = buff[8];
	NunchukState.CalibrationInfo.AccelCalibration.XG = buff[10];
	NunchukState.CalibrationInfo.AccelCalibration.YG = buff[11];
	NunchukState.CalibrationInfo.AccelCalibration.ZG = buff[12];
	NunchukState.CalibrationInfo.MaxX = buff[14];
	NunchukState.CalibrationInfo.MinX = buff[15];
	NunchukState.CalibrationInfo.MidX = buff[16];
	NunchukState.CalibrationInfo.MaxY = buff[17];
	NunchukState.CalibrationInfo.MinY = buff[18];
	NunchukState.CalibrationInfo.MidY = buff[19];
}

void WiiNunchakuConvert::ParseExtension(BYTE* buff)
{
	int offset = 6;
	NunchukState.RawJoystick.X = (int)buff[offset];
	NunchukState.RawJoystick.Y = (int)buff[offset+1];
	NunchukState.AccelState.RawValues.X = (int)buff[offset + 2];
	NunchukState.AccelState.RawValues.Y = (int)buff[offset + 3];
	NunchukState.AccelState.RawValues.Z = (int)buff[offset + 4];

	NunchukState.C = (buff[offset + 5] & 0x02) == 0;
	NunchukState.Z = (buff[offset + 5] & 0x01) == 0;

	NunchukState.AccelState.Values.X = (int)(((double)NunchukState.AccelState.RawValues.X - NunchukState.CalibrationInfo.AccelCalibration.X0) / 
		((double)NunchukState.CalibrationInfo.AccelCalibration.XG - NunchukState.CalibrationInfo.AccelCalibration.X0)*100);
	NunchukState.AccelState.Values.Y = (int)(((double)NunchukState.AccelState.RawValues.Y - NunchukState.CalibrationInfo.AccelCalibration.Y0) /
		((double)NunchukState.CalibrationInfo.AccelCalibration.YG - NunchukState.CalibrationInfo.AccelCalibration.Y0)*100);
	NunchukState.AccelState.Values.Z = (int)(((double)NunchukState.AccelState.RawValues.Z - NunchukState.CalibrationInfo.AccelCalibration.Z0) /
		((double)NunchukState.CalibrationInfo.AccelCalibration.ZG - NunchukState.CalibrationInfo.AccelCalibration.Z0)*100);

	if(NunchukState.CalibrationInfo.MaxX != 0x00)
	{
		NunchukState.Joystick.X = (int)(((double)NunchukState.RawJoystick.X - NunchukState.CalibrationInfo.MidX) / 
		((double)NunchukState.CalibrationInfo.MaxX - NunchukState.CalibrationInfo.MinX)*200);
	}

	if(NunchukState.CalibrationInfo.MaxY != 0x00)
	{
		NunchukState.Joystick.Y = (int)(((double)NunchukState.RawJoystick.Y - NunchukState.CalibrationInfo.MidY) / 
		((double)NunchukState.CalibrationInfo.MaxY - NunchukState.CalibrationInfo.MinY)*200);
	}
}