// -*-C++-*-
/*!
 * @file  WiiInfoSVC_impl.cpp
 * @brief Service implementation code of WiiInfo.idl
 *
 * @author 〒135-8548
 * 東京都江東区豊洲3-7-5　芝浦工業大学　研究棟　11-Q-32
 * 水川(HRI)研究室
 * 代表者:水川　真   (Emai:mizukawa<at>sic.shibaura-it.ac.jp)
 * 作成者;田中　基雅(Email:m108081<at>shibaura-it.ac.jp)
 *           藤田　恒彦(Email:m109077<at>shibaura-it.ac.jp)
 *           鷹栖　尭大（Email:m109056<at>shibaura-it.ac.jp）
 *
 * Microsoftより提供されているWindows Driver Kitのライブラリを除き，芝浦工業大学
 * 水川研究室に帰属します．
 * 非営利目的利用は自由です．
 *
 */

#include "WiiInfoSVC_impl.h"

/*
 * Example implementational code for IDL interface WiiInfo
 */
WiiInfoSVC_impl::WiiInfoSVC_impl()
{
  // Please add extra constructor code here.
}


WiiInfoSVC_impl::~WiiInfoSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
Calibration* WiiInfoSVC_impl::get_wii_ext_calib()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <Calibration* WiiInfoSVC_impl::get_wii_ext_calib()>"
#endif
	Calibration_var Wii_Ext_var;
	Wii_Ext_var = new Calibration(m_valueWiiExtensionCalibration);
	return Wii_Ext_var._retn();
}

Calibration* WiiInfoSVC_impl::get_balance_calib()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <Calibration* WiiInfoSVC_impl::get_balance_calib()>"
#endif
	Calibration_var Balance_var;
	Balance_var = new Calibration(m_valueWiiBalanceCalibration);
	return Balance_var._retn();
}

Calibration* WiiInfoSVC_impl::get_wii_mote_calib()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <Calibration* WiiInfoSVC_impl::get_wii_mote_calib()>"
#endif
	Calibration_var Wiimote_var;
	Wiimote_var = new Calibration(m_valueWiiRemoteCalibration);
	return Wiimote_var._retn();
}

CORBA::Octet WiiInfoSVC_impl::get_battery_value()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Octet WiiInfoSVC_impl::get_battery_value()>"
#endif
  	return m_valueBattery;
}

Extension* WiiInfoSVC_impl::get_wii_ext_state()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <Extension* WiiInfoSVC_impl::get_wii_ext_state()>"
#endif
  	Extension_var Ext_var;
	Ext_var = new Extension(m_valueWiiState);
	return Ext_var._retn();
}



// End of example implementational code



